/* 
 *    Copyright 2007 Takefumi MIYOSHI
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

/**
 * MICSのエンジンおよびMICSで規定するインターフェースの定義などのパッケージ
 */
package net.wasamon.mics;

/**
 * MICSシミュレーション要素が通信路へのソースとなりえる場合に実装すべきインターフェース
 * @author Takefumi MIYOSHI
 *
 */
public interface ChannelConnectable extends IMicsElement {

	/**
	 * 通信路へリクエストした結果を書き戻してもらうためのメソッド
	 */
	public void writeback(Channel src, MicsDataPacket data) throws MicsException;

	/**
	 * 接続相手の通信路に対するオフセット値を返す
	 * @param 接続相手のオフセット
	 * @return
	 * @deprecated writebackの引数のChannelをみて、クラス自身で解決してください
	 */
	public int getChannelOffset(Channel c);

}
